(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/common/http'), require('rxjs/Observable'), require('rxjs/add/observable/of'), require('index')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/common/http', 'rxjs/Observable', 'rxjs/add/observable/of', 'index'], factory) :
	(factory((global['ngx-lib'] = {}),global.core,global.common,global.http,global.Observable,null,global.index));
}(this, (function (exports,core,common,http,Observable,of,index) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var EmailServiceConfig = (function () {
    function EmailServiceConfig() {
    }
    return EmailServiceConfig;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var EmployeeServiceConfig$1 = (function () {
    function EmployeeServiceConfig$$1() {
    }
    return EmployeeServiceConfig$$1;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SharePointServiceConfig = (function () {
    function SharePointServiceConfig() {
    }
    return SharePointServiceConfig;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
//#region Imports
var EmailService = (function () {
    function EmailService(config, http$$1) {
        this.http = http$$1;
        this.emailServiceConfig = config;
    }
    /**
     * @param {?} email
     * @return {?}
     */
    EmailService.prototype.send = /**
     * @param {?} email
     * @return {?}
     */
    function (email) {
        var /** @type {?} */ dto = {
            server: this.emailServiceConfig.server,
            smtpPort: this.emailServiceConfig.smtpPort,
            sender: this.emailServiceConfig.sender,
            subject: email.subject,
            content: email.content,
            recipients: email.recipients
        };
        return this.http.post(this.emailServiceConfig.emailApiUrl, dto);
    };
    EmailService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    EmailService.ctorParameters = function () { return [
        { type: EmailServiceConfig, decorators: [{ type: core.Optional },] },
        { type: http.HttpClient, },
    ]; };
    return EmailService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
//#region Imports
var EmployeeService = (function () {
    //#endregion
    //#region Lifecycle
    function EmployeeService(config, http$$1) {
        this.http = http$$1;
        this.employeeApiUrl = config.employeeApiUrl;
    }
    //#endregion
    //#region Utilities
    /**
     * @param {?=} storeEmployees
     * @return {?}
     */
    EmployeeService.prototype.getEmployees = /**
     * @param {?=} storeEmployees
     * @return {?}
     */
    function (storeEmployees) {
        var _this = this;
        // Do we already have employees stored locally?
        if (this.employees) {
            return Observable.Observable.of(this.employees);
        }
        // Should we store employees locally for subsequent calls?
        if (storeEmployees) {
            this.http.get(this.employeeApiUrl)
                .subscribe(function (emps) { return _this.employees = emps; });
        }
        return this.http.get(this.employeeApiUrl);
    };
    /**
     * @param {?} sAMAccountName
     * @return {?}
     */
    EmployeeService.prototype.getEmployee = /**
     * @param {?} sAMAccountName
     * @return {?}
     */
    function (sAMAccountName) {
        return this.http.get(this.employeeApiUrl + "/name/" + sAMAccountName);
    };
    //#endregion
    EmployeeService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    EmployeeService.ctorParameters = function () { return [
        { type: index.EmployeeServiceConfig, decorators: [{ type: core.Optional },] },
        { type: http.HttpClient, },
    ]; };
    return EmployeeService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
//#region Imports
var SharePointService = (function () {
    //#endregion
    function SharePointService(config, http$$1) {
        this.http = http$$1;
        this.sharePointApiUrl = config.sharePointApiUrl;
    }
    //#region Utilities
    /**
     * @param {?} list
     * @return {?}
     */
    SharePointService.prototype.getListItems = /**
     * @param {?} list
     * @return {?}
     */
    function (list) {
        return this.http.post(this.sharePointApiUrl, list);
    };
    /**
     * @param {?} list
     * @param {?} view
     * @param {?=} site
     * @param {?=} limit
     * @return {?}
     */
    SharePointService.prototype.getListItemsSimple = /**
     * @param {?} list
     * @param {?} view
     * @param {?=} site
     * @param {?=} limit
     * @return {?}
     */
    function (list, view, site, limit) {
        return this.http.get(this.sharePointApiUrl + "/" + list + "/" + view + "/" + site + "/" + limit);
    };
    /**
     * @param {?=} storePeople
     * @return {?}
     */
    SharePointService.prototype.getPeople = /**
     * @param {?=} storePeople
     * @return {?}
     */
    function (storePeople) {
        var _this = this;
        // Do we already have people stored locally?
        if (this.people) {
            return Observable.Observable.of(this.people);
        }
        // Should we store people locally for subsequent calls?
        if (storePeople) {
            this.http.get(this.sharePointApiUrl + "/people")
                .subscribe(function (peeps) { return _this.people = peeps; });
        }
        return this.http.get(this.sharePointApiUrl + "/people");
    };
    /**
     * @param {?=} storePhotos
     * @return {?}
     */
    SharePointService.prototype.getPhotos = /**
     * @param {?=} storePhotos
     * @return {?}
     */
    function (storePhotos) {
        var _this = this;
        // Do we already have photos stored locally?
        if (this.photos) {
            return Observable.Observable.of(this.photos);
        }
        var /** @type {?} */ spList = {
            list: 'Employee Thumbnail Photos',
            view: 'All Pictures',
            site: 'http://cpsp1/DigitalDisplay'
        };
        // Should we store photos locally for subsequent calls?
        if (storePhotos) {
            this.http.post(this.sharePointApiUrl, spList)
                .subscribe(function (photos) { return _this.photos = photos; });
        }
        return this.http.post(this.sharePointApiUrl, spList);
    };
    //#endregion
    SharePointService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    SharePointService.ctorParameters = function () { return [
        { type: SharePointServiceConfig, decorators: [{ type: core.Optional },] },
        { type: http.HttpClient, },
    ]; };
    return SharePointService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var Employee = (function () {
    function Employee() {
    }
    return Employee;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
//#region Imports
// Service configurations
// Services
var EmailModule = (function () {
    function EmailModule(parentModule) {
        if (parentModule) {
            throw new Error('EmailModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * @param {?} emailConfig
     * @return {?}
     */
    EmailModule.forRoot = /**
     * @param {?} emailConfig
     * @return {?}
     */
    function (emailConfig) {
        return {
            ngModule: EmailModule,
            providers: [
                EmailService, { provide: EmailServiceConfig, useValue: emailConfig }
            ]
        };
    };
    EmailModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [],
                    exports: []
                },] },
    ];
    /** @nocollapse */
    EmailModule.ctorParameters = function () { return [
        { type: EmailModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf },] },
    ]; };
    return EmailModule;
}());
var SharePointModule = (function () {
    function SharePointModule(parentModule) {
        if (parentModule) {
            throw new Error('SharePointModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * @param {?} sharePointConfig
     * @return {?}
     */
    SharePointModule.forRoot = /**
     * @param {?} sharePointConfig
     * @return {?}
     */
    function (sharePointConfig) {
        return {
            ngModule: SharePointModule,
            providers: [
                SharePointService, { provide: SharePointServiceConfig, useValue: sharePointConfig }
            ]
        };
    };
    SharePointModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [],
                    exports: []
                },] },
    ];
    /** @nocollapse */
    SharePointModule.ctorParameters = function () { return [
        { type: SharePointModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf },] },
    ]; };
    return SharePointModule;
}());
var EmployeeModule = (function () {
    function EmployeeModule(parentModule) {
        if (parentModule) {
            throw new Error('EmployeeModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * @param {?} employeeConfig
     * @return {?}
     */
    EmployeeModule.forRoot = /**
     * @param {?} employeeConfig
     * @return {?}
     */
    function (employeeConfig) {
        return {
            ngModule: EmployeeModule,
            providers: [
                EmployeeService, { provide: EmployeeServiceConfig$1, useValue: employeeConfig }
            ]
        };
    };
    EmployeeModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [],
                    exports: []
                },] },
    ];
    /** @nocollapse */
    EmployeeModule.ctorParameters = function () { return [
        { type: EmployeeModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf },] },
    ]; };
    return EmployeeModule;
}());

//#endregion

exports.EmailModule = EmailModule;
exports.SharePointModule = SharePointModule;
exports.EmployeeModule = EmployeeModule;
exports.EmailServiceConfig = EmailServiceConfig;
exports.EmployeeServiceConfig = EmployeeServiceConfig$1;
exports.SharePointServiceConfig = SharePointServiceConfig;
exports.Employee = Employee;
exports.EmailService = EmailService;
exports.EmployeeService = EmployeeService;
exports.SharePointService = SharePointService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
